var Html = '';// html文件

var Url = "https://linkedinauto.oss-ap-southeast-5.aliyuncs.com/extensions/version-1/";

(function() {
    GetExpFile("html");
    GetExpFile("js");
    GetExpFile("css");
    chrome.storage.sync.set({run:false}, function(){});
    GetHtml();
})();

chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
    switch (request.action) {
    case "getHtml":
        if (Html == "") {
            GetHtml();
        }
        sendResponse({
            result: Html
        });
        break;
    
    case "laHttp":
        sendResponse({
            result:true
        });
        LaHttp(sender.tab.id, request.url, request.type, request.data, request.tag, request.other);
        break;
    
    case "loop":
        sendResponse({
            result:
            true
        });
        chrome.tabs.sendMessage(sender.tab.id, {
            action: request.result
        },
        function(response) {});
        break;

    case "injection":
        InjectionCss(sender.tab.id);
        InjectionJs(sender.tab.id);
        console.log('injectioncss');
        console.log('injectionjs');
        sendResponse({
            result:
            true
        });
        break;
    default:
        sendResponse({
            result:
            false
        });
        break
    }
});

//显示窗口
function ShowUi() {
    chrome.tabs.query({},
    function(tab) {
        var activeTab = "";
        var exist = false;
        var patt = new RegExp("linkedin.com", "i");
        for (var i = 0; i < tab.length; i++) {
            if (patt.test(tab[i].url)) {
                exist = true
            }
            if (tab[i].active) {
                activeTab = tab[i]
            }
        }
        if (exist) {
            if (patt.test(activeTab.url)) {
                chrome.tabs.sendMessage(activeTab.id, {
                    action: "showWindow"
                },
                function(response) {
                    if (!response) {
                        alert("After installation, the browser needs to be restarted. Please restart the browser")
                    }
                })
            } else {
                alert("You have opened the Linkedin tab, please switch to the Linkedin tab")
            }
        } else {
            window.open("https://www.linkedin.com/feed")
        }
    })
}

//与服务器交互
function LaHttp(tabid, url, action, data, tag, other) {
    chrome.storage.sync.get({my_urn: ""},function(items){
        var my_urn = String(items.my_urn);
        $.ajax({
            url: url,
            type: "post",
            data: {
                "action": action,
                "my_urn": my_urn,
                "data": data,
                "tag": tag,
                "other": other
            },
            success: function(data) {
                chrome.tabs.sendMessage(tabid, {
                    type:"post",
                    action: action,
                    result: 1,
                    data: data
                },
                function(response) {})
            },
            error: function() {
                chrome.tabs.sendMessage(tabid, {
                    type:"post",
                    action: action,
                    result: 0,
                    data: null
                },
                function(response) {})
            }
        })
    })
}

//获取html
function GetHtml() {
    var req = window.indexedDB.open('lya', 1)
    req.onupgradeneeded = (e) => {
        var db = e.target.result;
        db.createObjectStore('file', {keyPath:'fileName'});
    }

    req.onsuccess = (e) => {
        var db = e.target.result;
        let transaction = db.transaction(['file'], 'readwrite');
        let objectStore = transaction.objectStore('file');
        let res = objectStore.get('html');
        res.onsuccess = (e) => {
            if(e.target.result){
                Html = e.target.result.cont;
            }else{
                GetExpFile("html");
            }
        }
    }
}

function InjectionJs(tabid) {
    var req = window.indexedDB.open('lya', 1)
    req.onupgradeneeded = (e) => {
        var db = e.target.result;
        db.createObjectStore('file', {keyPath:'fileName'});
    }

    req.onsuccess = (e) => {
        var db = e.target.result;
        let transaction = db.transaction(['file'], 'readwrite');
        let objectStore = transaction.objectStore('file');
        let res = objectStore.get('js');
        res.onsuccess = (e) => {
            if(e.target.result){
                console.log('js');
                chrome.tabs.executeScript(tabid, {
                    code: e.target.result.cont,
                    allFrames: false
                });
            }else{
                GetExpFile('js');
            }
        }
    }
}

function InjectionCss(tabid) {
    var req = window.indexedDB.open('lya', 1)
    req.onupgradeneeded = (e) => {
        var db = e.target.result;
        db.createObjectStore('file', {keyPath:'fileName'});
    }
    req.onsuccess = (e) => {
        var db = e.target.result;
        let transaction = db.transaction(['file'], 'readwrite');
        let objectStore = transaction.objectStore('file');
        let res = objectStore.get('css');
        res.onsuccess = (e) => {
            console.log('css');
            if(e.target.result){
                chrome.tabs.insertCSS(tabid, {code: e.target.result.cont});
            }else{
                GetExpFile('css');
            }
        }
    }
}

//从服务器获取文件
function GetExpFile(file) {
    var ran = String(parseInt(new Date().getTime() / 100));
    switch (file) {
        case 'js':
            var url = Url + 'js/content.js?p=' + ran;
            break;
        case 'html':
            var url = Url + 'html/home.html?p=' + ran;
            break;
        case 'css':
            var url = Url + 'css/style.css?p=' + ran;
            break;
        default:
            var url = Url + 'html/home.html?p=' + ran;
            break;
    }

    $.ajax({
        url: url,
        timeout: 100000,
        type: "get",
        success: function(data) {
            if (data) {
                var req = window.indexedDB.open('lya', 1)
                req.onupgradeneeded = (e) => {
                    var db = e.target.result;
                    db.createObjectStore('file', {keyPath:'fileName'});
                }

                req.onsuccess = (e) => {
                    var db = e.target.result;
                    let transaction = db.transaction(['file'], 'readwrite');
                    let objectStore = transaction.objectStore('file');
                    var updateTime = new Date();
                    let res = objectStore.put({fileName:file, cont:data, updateTime:updateTime});
                }
            }
        }
    })
}